# This script generates HEX formatted char array from input file.
#
# Usage:
#   cmake -P generate_char_array.cmake <input file> <output file>
#
# Example of input file:
#   This is a test\n
#
# Example of output file:
#   0x54, 0x68, 0x69, 0x73, 0x20, 0x69, 0x73, 0x20, 0x61, 0x20, 0x74, 0x65, 0x73, 0x74, 0x0a,
#
file(READ ${CMAKE_ARGV3} hex_data HEX)
string(REGEX REPLACE "([0-9a-f][0-9a-f])" "0x\\1, " hex_split ${hex_data})
file(WRITE ${CMAKE_ARGV4} "/* Generated by generate_char_array.cmake */\n")
file(APPEND ${CMAKE_ARGV4} ${hex_split})
